public interface OrderedList<E> {
    // Overview: Tipo modificabile che rappresenta una lista ordinata di elementi di E
    // Typical Element: <e_1, ..., e_k> lista di elementi di tipo E con e_i <= e_j se i <= j

     /* inserisce l'elemento elem nella lista rispettando l'ordine */
     public void insert(E elem) throws NullPointerException;
     /* 
      MODIFIES: this
      EFFECTS: se elem != null lo inserisce nella lista rispettando l'ordinamento,
      altrimenti lancia una NullPointerException (eccezione disponibile in Java, unchecked)
      */  
      
     /* restituisce ed elimina dalla lista l'elemento minimo rispetto all'ordine */
     public E extractMin() throws EmptyListException;
     /* 
      MODIFIES: this
      EFFECTS: se la lista non e' vuota toglie toglie dalla lista l'elemento minimo e lo restituisce, 
      altrimenti lancia una EmptyListException (eccezione non disponibile in Java, checked)
      */  
}